#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class LinearRegression : Strategy
    {
        #region Variables
        // Wizard generated variables
        private int stdDevPeriod = 100; // Default setting for StdDevPeriod
        private double stdDevWidth = 2.000; // Default setting for StdDevWidth
        private double slope = .0001; // Default setting for Slope
        private double takeProfit = 2; // Default setting for TakeProfit
        private int stdDevPeriod2 = 120; // Default setting for StdDevPeriod2
        private int stdDevWidth2 = 2; // Default setting for StdDevWidth2
        private double slope2 = 1; // Default setting for Slope2
        private bool add2ndPeriod = false; // Default setting for Add2ndPeriod
        // User defined variables (add any user defined variables below)
        #endregion
		
		private double target = 0.00;
		private double stop = 0.00;
		private double entry = 0.00;
		private double oneProfit =0.00;
		private int shares = 10000;
		//private double finalStop = 0.00;
		//private double finalEntry = 0.00;
		//private double finalTarget = 0.00;
		private double StopWiggle = 0.0003;
		
		

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
			//Add(PeriodType.Minute, 1);
			//Add(PeriodType.Minute, 60);
			//Add(PeriodType.Range, 20);			
			
            CalculateOnBarClose = true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {

			if (CurrentBar <60){return;}
			
    //    if (ToTime(Time[0]) <= 70000 || ToTime(Time[0]) >= 150000)
	//	{//no initiating trades before 7:00am and after 3:00pm
	//		return;
	//	}			
			
 /*         if (ToTime(Time[0]) >= 230000 && ToTime(Time[0]) <= 70000){//no trades after 6:45 and before 15:45 
			return;
		}
		
        if (ToTime(Time[0]) >= 164500 && ToTime(Time[0]) <= 233000){//no trades after 16:45 and before 23:30
			return;
		}
		
         if (ToTime(Time[0]) >= 10000 && ToTime(Time[0]) <= 43000){//no trades after 1:00 and before 4:30
			return;
		}	*/	

			
			
			
			//Target will change to end of regression channel on bar update if middle line crossed by low of bar
			if(Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Long
				&& Low[0]> RegressionChannel(stdDevPeriod,stdDevWidth).Middle[0])
			{
			target = RegressionChannel(stdDevPeriod,stdDevWidth).Upper[0];
			SetProfitTarget("ltarget1",CalculationMode.Price, target);	
			}
			if(Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Short
				&& High[0]< RegressionChannel(stdDevPeriod,stdDevWidth).Middle[0] )
			{
			target = RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0];
			SetProfitTarget("ltarget1",CalculationMode.Price,target);	
			}
			
	
			
/*newCodeStart*/			
			if(//move stop up to break even+ after being positive
				Low[0] >= entry +0.0001
				&& Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Long)
			{


				//finalEntry = Highs[1][0]+ 0.0000;
				//finalStop = Lows[1][1]- StopWiggle;
				//finalTarget = ((entry + finalEntry)/2+.0009);
				//stop = finalStop - 0.1;
				
				//EnterLong(shares,"ltarget3");
				//SetProfitTarget("ltarget13",CalculationMode.Price, finalTarget);
            	//SetStopLoss("ltarget3",CalculationMode.Price, finalStop-0.01,true);
				//SetProfitTarget("ltarget1",CalculationMode.Price, finalTarget);
				SetStopLoss("ltarget1",CalculationMode.Price, entry+0.0001,true);
				
			
			}
			
			
			
			
			if(
				High[0] <= entry -0.0001
				&& Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Short)				
			{


				//finalEntry = Lows[1][0] -0.0000;
				//finalStop = Highs[1][1]+ StopWiggle;
				//finalTarget =((entry + finalEntry)/2)-0.0009;
				//stop = finalStop + 0.1;
				
				//EnterShort(shares,"starget3");
				//SetProfitTarget("starget3",CalculationMode.Price, finalTarget);
            	//SetStopLoss("starget3",CalculationMode.Price, finalStop+0.01,true);
				//SetProfitTarget("starget1",CalculationMode.Price, finalTarget);
				SetStopLoss("starget1",CalculationMode.Price, entry -0.0001,true);
				
            }
			
			
       				
				
/*endNewCode */					
			
			

			
			
/*remove--this for resetting stop
			

				
			if(//Position.GetProfitLoss(High[0], PerformanceUnit.Currency) >= oneProfit*2
				High[0] > target
				&& Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Long)
			{
				SetStopLoss("ltarget2",CalculationMode.Price, entry+0.0005, true);//oneProfit/2
				//Print(Position.GetProfitLoss(High[0], PerformanceUnit.Currency) + "  Lpl  "+ oneProfit);
			}
				
			if (//Position.GetProfitLoss(Low[0], PerformanceUnit.Currency) >= oneProfit*2
				Low[0] < target
				&& Position.MarketPosition != MarketPosition.Flat
				&& Position.MarketPosition == MarketPosition.Short)
			{
					SetStopLoss("starget2",CalculationMode.Price, entry-0.0005, true);//oneProfit/2
					//Print(Position.GetProfitLoss(Low[0], PerformanceUnit.Currency)+ "   Spl  " + oneProfit);
			}

*///remove
			
			

			
			

						

			
		
            if (Position.MarketPosition == MarketPosition.Flat
				&& DeanSemaphore(stdDevPeriod,stdDevWidth,25,6).GoBuy[0] == 2
				&& RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0]> RegressionChannel(stdDevPeriod,stdDevWidth).Lower[5] + slope
				//&& DeanSemaphore(BarsArray[1],stdDevPeriod2,stdDevWidth,25,6).GoBuy[0] == 2
				 )
            {

				/*if(Highs[1][0] - Lows[1][1] > 0.60){
                EnterLongLimit(1,false,1000,(Lows[1][1]+ 0.60), "");
				SetProfitTarget(CalculationMode.Price, (Highs[1][0] + ((Highs[1][0]-Lows[1][1]))));
            	SetStopLoss(CalculationMode.Price, (Lows[1][1]- StopWiggle));
				
				}
				else{
				EnterLongLimit(1000, (Highs[1][0] + 0.02), "");
				SetProfitTarget(CalculationMode.Price, (Highs[1][0] + ((Highs[1][0]-Lows[1][1]))));
            	SetStopLoss(CalculationMode.Price, (Lows[1][1]- StopWiggle));
				
				}*/
				

				
				entry =High[0];
				stop = MIN(Low,5)[0] - StopWiggle;
				target = (High[0]+ (takeProfit*(entry - stop)));
				oneProfit = (target - entry);
				
				/*if(RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0]> RegressionChannel(stdDevPeriod,stdDevWidth).Lower[5] + slope + 0.0007)
				{
					//target = (High[0]+ ((2*takeProfit)*(entry - stop)));
					target = RegressionChannel(stdDevPeriod,stdDevWidth).Upper[0];
				}*/				
				
				
				
				
				
				/*entry = Highs[1][0]+ 0.00;
				stop = Lows[1][1]- StopWiggle;
				target = (Highs[1][0] + (entry-stop));
				oneProfit= /*shares**///(target - entry);
				
				EnterLong(shares,"ltarget1");
				SetProfitTarget("ltarget1",CalculationMode.Price, target);
            	SetStopLoss("ltarget1",CalculationMode.Price, (stop),true);
				//EnterLong(shares,"ltarget2");
				//SetProfitTarget("ltarget2",CalculationMode.Price, (target + (target - entry)));
            	//SetStopLoss("ltarget2",CalculationMode.Price, stop,true);
				
            }
			
			if (Position.MarketPosition == MarketPosition.Flat
				&& DeanSemaphore(stdDevPeriod,stdDevWidth,25,6).GoSell[0] == -2
				&& RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0]< RegressionChannel(stdDevPeriod,stdDevWidth).Lower[5]- slope
				//&& DeanSemaphore(BarsArray[1],stdDevPeriod2,stdDevWidth,25,6).GoSell[0] == -2
				)
				
            {
				
				/*if (Highs[1][1] - Lows[1][0]>0.60){	
                EnterShortLimit(1,false,1000, (Highs[1][1]- 0.60), "");
				SetProfitTarget(CalculationMode.Price, (Lows[1][0] - ((Highs[1][1]-Lows[1][0]))));
            	SetStopLoss(CalculationMode.Price, (Highs[1][1]+ StopWiggle));
				
				}
				else{
                EnterShortLimit(1000, (Lows[1][0]- 0.02), "");
				SetProfitTarget(CalculationMode.Price, (Lows[1][0] - ((Highs[1][1]-Lows[1][0]))));
            	SetStopLoss(CalculationMode.Price, (Highs[1][1]+ StopWiggle));
				
				}*/	
				
				entry =Low[0];
				stop = MAX(High,5)[0] + StopWiggle;
				target = (Low[0]- (takeProfit*(stop -entry)));
				oneProfit = (entry - target);
				
				/*if(RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0]<RegressionChannel(stdDevPeriod,stdDevWidth).Lower[5] - slope - 0.0007)
				{
					//target = (Low[0]- ((2*takeProfit)*(stop -entry)));
					target = RegressionChannel(stdDevPeriod,stdDevWidth).Lower[0];
				}*/								
				
				
				/*entry = Lows[1][0] -0.00;
				stop = Highs[1][1]+ StopWiggle;
				target =Lows[1][0] - (stop-entry);
				oneProfit = /*shares**///(entry - target);
				
				EnterShort(shares,"starget1");
				SetProfitTarget("starget1",CalculationMode.Price, target);
            	SetStopLoss("starget1",CalculationMode.Price, (stop),true);
				//EnterShort(shares,"starget2");
				//SetProfitTarget("starget2",CalculationMode.Price, (target - (entry - target)));
            	//SetStopLoss("starget2",CalculationMode.Price, stop,true);
				
            }
						
			
			
			
			
			
			
        }

        #region Properties
        [Description("")]
        [Category("Parameters")]
        public int StdDevPeriod
        {
            get { return stdDevPeriod; }
            set { stdDevPeriod = Math.Max(1, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public double StdDevWidth
        {
            get { return stdDevWidth; }
            set { stdDevWidth = Math.Max(0.01, value); }
        }

        [Description("no more than a few pips (ie: EURUSD change to 0.0002")]
        [Category("Parameters")]
        public double Slope
        {
            get { return slope; }
            set { slope = Math.Max(0.0001, value); }
        }

        [Description(" the ratio of TP. 1 is 1:1, 2 is 2:1 etc.")]
        [Category("Parameters")]
        public double TakeProfit
        {
            get { return takeProfit; }
            set { takeProfit = Math.Max(0.0001, value); }
        }

        [Description(" not set up")]
        [Category("Parameters")]
        public int StdDevPeriod2
        {
            get { return stdDevPeriod2; }
            set { stdDevPeriod2 = Math.Max(1, value); }
        }

        [Description("not set up")]
        [Category("Parameters")]
        public int StdDevWidth2
        {
            get { return stdDevWidth2; }
            set { stdDevWidth2 = Math.Max(0, value); }
        }

        [Description("not set up")]
        [Category("Parameters")]
        public double Slope2
        {
            get { return slope2; }
            set { slope2 = Math.Max(0.000, value); }
        }

        [Description(" not set up")]
        [Category("Parameters")]
        public bool Add2ndPeriod
        {
            get { return add2ndPeriod; }
            set { add2ndPeriod = value; }
        }
        #endregion
    }
}
